/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.velocitycore.listeners;

import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.player.CookieReceiveEvent;
import com.velocitypowered.api.proxy.Player;
import de.steamwar.linkage.EventMode;
import de.steamwar.linkage.Linked;
import de.steamwar.sql.EventFight;
import de.steamwar.sql.SteamwarUser;
import de.steamwar.velocitycore.EventStarter;
import de.steamwar.velocitycore.VelocityCore;

@Linked
@EventMode(false)
public class CookieEvents extends BasicListener {

    @Subscribe
    public void handleCookies(CookieReceiveEvent e) {
        System.out.println(e.getOriginalKey() + " " + e.getOriginalData());
        if (!e.getOriginalKey().namespace().equals(EventModeListener.EVENT_TO_SPECTATE_KEY.namespace())) return;
        if (!e.getOriginalKey().value().equals(EventModeListener.EVENT_TO_SPECTATE_KEY.value())) return;
        e.setResult(CookieReceiveEvent.ForwardResult.handled());
        Player player = e.getPlayer();
        SteamwarUser user = SteamwarUser.get(player.getUniqueId());

        EventFight.getActiveFights().stream()
                .filter(fight -> fight.getTeamRed() == user.getTeam() || fight.getTeamBlue() == user.getTeam())
                .filter(fight -> fight.getSpectatePort() != null)
                .filter(fight -> fight.getSpectatePort() != 0)
                .findFirst()
                .flatMap(fight -> VelocityCore.getProxy().getServer(EventStarter.getSpectatePorts().get(fight.getSpectatePort())))
                .ifPresent(registeredServer -> player.createConnectionRequest(registeredServer).fireAndForget());
    }
}
